<template>
  <pageWrapper
    title="Support chat 24/7"
    backable
    closable
    hideFooter
    :closable="showingMenu"
    @close="closeAll"
    @back="close"
    :defaultScroll="true"
    gradient
    ref="pageWrapper"
  >
    <div class="chat_body">
    </div>
  </pageWrapper>
</template>

<script>
  import pageWrapper from '~/components/common/pageWrapper';
  import * as Zammad from '~/plugins/zammad';

  export default {
    name: "index",
    data() {
      return {
        msg: '',
        zammadChat: null,
        interval: null,
        forceOpen: false
      }
    },
    components: {
      pageWrapper
    },
    computed: {
      showingMenu() {
        return this.$store.state.common.showingMenu;
      }
    },
    methods: {
      closeAll() {
        this.close();
        this.$root.$refs['headerTop'].openMenu(false);
      },
      close() {
        this.$emit('close');
        this.enableScroll();
      },
      enableScroll() {
        this.$refs['pageWrapper'].enableScroll();
      },
      disableScroll() {
        this.$refs['pageWrapper'].disableScroll();
      },
      enableChat() {
        this.disableScroll();
        if (!this.zammadChat) {
          this.chatInit();
          this.checkReconnect();
        }
        //this.zammadChat && this.zammadChat.open();
      },
      checkReconnect() {
        if (this.zammadChat.state === 'offline') {
          this.forceOpen = true;

          if (!this.interval) {
            this.interval = setInterval(_ => {
              this.checkReconnect();
            }, 1500);
          } else {
            this.chatInit();
          }
        } else {
          this.interval && clearInterval(this.interval);
        }
      },
      chatInit() {
        this.zammadChat = new ZammadChat({
          chatId: 1,
          show: false,
          flat: true,
          debug: false,
          target: $('.chat_body'),
          host: 'wss://support.16bit.game/ws',
          cssAutoload: false
        });
        if (!this.zammadChat.cb) this.zammadChat.cb = () => {
          this.forceOpen && this.zammadChat.open();
        }
      }
    }
  }
</script>
